/*
 * Copyright 2016 - 2023 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#pragma once

#include <studio/studio.hpp>

#include <nostalgia/core/gfx.hpp>
#include <nostalgia/core/palette.hpp>

namespace nostalgia::core {

class PaletteEditorImGui: public studio::Editor {

	private:
		turbine::Context *m_ctx = nullptr;
		ox::String m_itemPath;
		ox::String m_itemName;
		Palette m_pal;
		std::size_t m_selectedRow = 0;

		PaletteEditorImGui() noexcept = default;

	public:
		PaletteEditorImGui(turbine::Context *ctx, ox::String path);

		/**
		 * Returns the name of item being edited.
		 */
		const ox::String &itemName() const noexcept final;

		const ox::String &itemDisplayName() const noexcept final;

		void draw(turbine::Context*) noexcept final;

	protected:
		ox::Error saveItem() noexcept final;

};

}
